/*
Scrivere un programma per la gestione dei prestiti di una cdteca. Ciascun prestito e' caratterizzato dalle seguente informazioni:
codice identificativo del cliente, titolo dellalbum,  giorno della prenotazione,  genere di film (0=classisa, 1=metal, 2=pop, 3=rock).
I prestiti sono organizzati in memoria come una tabella con 4 righe, una per ogni genere, e 15 colonne.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
 1) Inserimento di un nuovo prestito;
 2) Visualizzazione dei prestiti relative a un certo genere;
 3) Salvataggio su file delle informazioni relative ai prestiti di un certo genere di film.

Allavvio del programma i prestiti precedentemente salvati su file devono essere letti e copiati nella tabella mediante
una funzione di inizializzazione della tabella.
*/


#include<stdio.h>
#include<string.h>
struct prestito
	{
		int codice;
		char titolo[50];
		char giorno[30];
		int genere;
	};

	void inserisci(struct prestito V[4][15],int *N)
		{
			struct prestito x;
			int riga;

			printf("Inserisci il codice identificativo del cliente:\n");
			scanf("%d",&x.codice);
			printf("Inserisci il titolo dell'album:\n");
			scanf("%s",x.titolo);
			printf("Inserisci il giorno della prenotazione:\n");
			scanf("%s",x.giorno);
			printf("Inserisci il genere(0=classica, 1=metal, 2=pop, 3=rock):\n");
			scanf("%d",&x.genere);
			riga=x.genere;

			if(N[riga]<15)
				{
					V[riga][N[riga]]=x;
					N[riga]++;
				}
			else printf("Il vettore  pieno\n");
		}

	void visualizza(struct prestito V[4][15], int *N)
		{
			int i,riga;

			printf("Inserisci il genere:\n");
			scanf("%d",&riga);

			for(i=0;i<N[riga];i++)
			{
				printf("Il codice e':%d\n",V[riga][i].codice);
				printf("Il titolo dell'album e':%s\n",V[riga][i].titolo);
				printf("Il giorno della prenotazione e':%s\n\n",V[riga][i].giorno);
			}

		}

	void salva(struct prestito V[4][15], int *N)
		{
			FILE *pf;
			int i, genere;

			printf("Inserire il genere:\n");
			scanf("%d",&genere);
			pf=fopen("cdteca.txt","w");
			if(pf==NULL)return;
				fwrite(V[genere],sizeof(struct prestito),N[genere],pf);
			fclose(pf);
		}


	void inizializza(struct prestito V[4][15], int *N)
		{
			int i, riga;
			FILE *pf;
			struct prestito x;

			pf=fopen("cdteca.txt","r");
			if(pf==NULL)return;

			while(fread(&x,sizeof(struct prestito),1,pf))
				{
					riga=x.genere;
					if(N[riga]<15);
						{
							V[riga][N[riga]]=x;
							N[riga]++;
						}
				}
			fclose(pf);
		}


	void menu()
		{
			printf("Scegli una delle seguenti opzioni:\n");
			printf("1)Inserimento\n");
			printf("2)Visualizza\n");
			printf("3)Salva\n");
			printf("0)Exit\n");
		}


	main()
	{
		struct prestito V[4][15];
		int N[4],i,scelta;



		for(i=0;i<4;i++)
			N[i]=0;

		inizializza(V,N);
		do
			{
				menu();
				scanf("%d",&scelta);
				switch(scelta)
					{
						case 1:inserisci(V,N);
								break;
						case 2:visualizza(V,N);
								break;
						case 3:salva(V,N);
								break;
						default:printf("ha effettuato una scelta errata");
					}
				}while(scelta!=0);
	}


